FIRMA1          equ  2387h
FIRMA2          equ  7A8Dh
codigo		segment
                assume cs:codigo
                org 100h               ;Inicio de programa .COM
inicio:         jmp short verif_instalac ;Saltar al codigo de instalacion.
viejo_int9      label dword
offset_int9     dw 0
segmento_int9   dw 0
Estado          db 1                   ;1: Habilitado; 0: No habilitado.
Firma           dw FIRMA1,FIRMA2
;
;  Manejador de la interrupcion 9 (teclado)
;
int9handler:    cmp Estado,0           ;Sonido habilitado?
                jz ir_a_viejo_INT9     ;Saltar si no es asi.
                push ax                ;Preservar registros utilizados.
		push cx
		push dx
                mov al,182             ;Generar onda cuadrada en timer 2
                out 67,al              ;para poder producir sonido.
                in al,96               ;Leer el controlador de teclado.
                cmp al,128             ;Ver si se apreto o solto una tecla.
                jnc silencio           ;Saltar si se solto.
                add al,al              ;Ajustar el codigo de exploracion:
                jns hallar_frec        ;cada dos valores se debe incrementar
                sub al,127             ;un semitono.
hallar_frec:    mov cl,al              ;CX = Cantidad de medios semitonos
                xor ch,ch              ;     por encima del LA (55 Hz).
                mov ax,21690           ;AX = 55 Hz (LA)
ciclo_frec:     mov dx,63670           ;DX = Medio semitono.
                mul dx                 ;DX = Siguiente medio semitono.
                mov ax,dx              ;AX = Siguiente medio semitono.
                loop ciclo_frec        ;Continuar calculando frecuencia.
                jmp short sonar        ;Ir a poner la nota.
silencio:       mov ax,40              ;Silencio.
sonar:          out 66,al              ;Poner la parte baja del contador.
		mov al,ah
                out 66,al              ;Poner la parte alta del contador.
                in al,97               ;Habilitar salida del parlante.
		or al,3
		out 97,al
                pop dx                 ;Restaurar registros utilizados.
		pop cx
		pop ax
ir_a_viejo_INT9:
                jmp viejo_int9         ;Ir al viejo manejador de la
                                       ;interrupcion del teclado.
;
; Instalacion del TSR.
;
verif_instalac: xor ax,ax              ;Apuntar a la tabla de interrupcion.
                mov es,ax
                lds bx,es:9*4          ;DS:BX = Puntero al manejador de la
                                       ;interrupcion del teclado.
                cmp word ptr [bx-4],FIRMA1  ;Si la firma no coincide,
                jne instalar                ;instalar el TSR.
                cmp word ptr [bx-2],FIRMA2  ;Si la firma no coincide,
                jne instalar                ;instalar el TSR.
                xor ds:Estado,1        ;Cambiar estado: sonido si/no.
		push cs
                pop ds                 ;DS = Segmento de codigo.
                mov dx,offset sonido_si ;Puntero a texto de sonido activado.
                jnz mostrar_texto
                mov dx,offset sonido_no ;Puntero a texto de sonido desactivado.
mostrar_texto:  mov ah,9
                int 21h                ;Llamar a funcion DOS para mostrarlo.
                in al,97               ;Deshabilitar sonido.
		and al,252
		out 97,al
                mov ax,4c00h           ;Fin del programa.
		int 21h
instalar:       mov offset_int9,bx     ;Preservar offset vieja interrupcion 9.
                mov segmento_int9,ds   ;Preservar segmento vieja int 9.
                cli                    ;Deshabilitar interrupciones.
                mov es:9*4,offset int9handler ;Nuevo offset interrupcion 9.
                mov es:9*4+2,cs        ;Nuevo segmento interrupcion 9.
                sti                    ;Habilitar interrupciones.
                push cs
                pop ds                  ;DS = Segmento de codigo.
                mov dx,offset sonido_si ;Mostrar texto de sonido habilitado.
		mov ah,9
		int 21h
                mov dx,offset verif_instalac  ;Instalar TSR.
		int 27h
sonido_si       db "Sonido activado.",13,10,"$"
sonido_no       db "Sonido desactivado.",13,10,"$"
codigo		ends
		end inicio
